%module LibDvdRead
%{
#include <stdio.h>
#include <dvdread/ifo_read.h>
%}


%inline %{
#ifndef SWIG
static char	volid [32];
static char	volsetid [128];
#endif


const char *
DVDVolumeIdentifier (dvd_reader_t *dvd)
{
  if (DVDUDFVolumeInfo (dvd, volid, sizeof (volid),
			volsetid, sizeof (volsetid)) < 0)
    return NULL;

  return volid;
}


const char *
DVDVolumeSetIdentifier (dvd_reader_t *dvd)
{
  if (DVDUDFVolumeInfo (dvd, volid, sizeof (volid),
			volsetid, sizeof (volsetid)) < 0)
    return NULL;

  return volsetid;
}


const char *
DVDDiscIdentifier (dvd_reader_t *dvd)
{
  static unsigned char discid [16];

  if (DVDDiscID (dvd, discid) < 0)
    return NULL;

  return discid;
}
%}


#define __extension__
#define __attribute__(x)
#define __const			const
#define __restrict
#define __inline

%include "ignores.i"
%include "ifo_read.i"


%include "carrays.i"
%array_functions(title_info_t, title_info_array);
%array_functions(ttu_t, ttu_array);
%array_functions(audio_attr_t, audio_attr_array);
%array_functions(subp_attr_t, subp_attr_array);
%array_functions(ptt_info_t, ptt_info_array);
%array_functions(pgci_srp_t, pgci_srp_array);
%array_functions(pgc_program_map_t, pgc_program_map_array);
%array_functions(cell_playback_t, cell_playback_array);
%array_functions(uint32_t, palette);


%constant int BLOCK_TYPE_NONE         = 0x0;
%constant int BLOCK_TYPE_ANGLE_BLOCK  = 0x1;
