#############################################################################
# ui.pm extension file, included from the puic-generated form implementation.
# If you wish to add, delete or rename signals or slots use
# the Perl-enabled Qt Designer which will update this file,
# preserving your code.
#
# 'SLOT:' markers are not meant to be created or edited manually.
# Please use the Slots dialog and/or the Object Browser.
#############################################################################


our $dvdr_total_sectors = read_setting ("/Vamps/dvdr_total_sectors");
our $dvdr_spare_sectors = read_setting ("/Vamps/dvdr_spare_sectors");


sub init
{
  my $extension = VTSList (this, "VTSList");
  setExtension ($extension);
  setOrientation (&Qt::Horizontal);
  showExtension (0);
  vts_list = $extension -> vts_list ();

  menu_preview = MenuPreview (undef, "menu_preview", 0,
			      &Qt::WType_Dialog       |&Qt::WStyle_Customize|
			      &Qt::WStyle_NormalBorder|&Qt::WStyle_Title    |
			      &Qt::WStyle_ContextHelp);

  my @devs = split_setting (read_setting ("/General/DVD_read_devices"));
  device_edit    -> insertStrList (\@devs);
  base_path_edit -> setText (read_setting ("/Dvdauthor/base_path"));

  settings_mapping =
  {
    "/General/language"                => \lang_edit,
    "/General/DVD_burner"              => \dvd_burner_edit,
    "/General/DVD_burn_speed"          => \dvd_burn_speed_spin_box,

    "/MediaPlayer/play_dvd_title"      => \play_dvd_title_edit,
    "/MediaPlayer/play_dvd_cells"      => \play_dvd_cells_edit,
    "/MediaPlayer/select_angle"        => \player_select_angle_edit,
    "/MediaPlayer/select_audio"        => \player_select_audio_edit,
    "/MediaPlayer/select_subtitle"     => \player_select_subtitle_edit,

    "/Dvdauthor/base_path"             => \base_path_edit,
    "/Dvdauthor/command"               => \dvdauthor_cmd_edit,
    "/Dvdauthor/spumux_mpv"            => \spumux_mpv_edit,
    "/Dvdauthor/spumux_mpg"            => \spumux_mpg_edit,
    "/Dvdauthor/burn_cmd"              => \burn_cmd_edit,

    "/Vamps/evaporate_cell"            => \evaporate_cell_edit,
    "/Vamps/select_subtitles"          => \vamps_select_subtitles_edit,
    "/Vamps/dvdr_total_sectors"        => \dvdr_total_spin_box,
    "/Vamps/dvdr_spare_sectors"        => \dvdr_spare_spin_box,

    "/Menu/Preferences/tv_standard"    => \tv_standard_combo,
    "/Menu/Preferences/background"     => \pref_background_edit,
    "/Menu/Preferences/audio_es"       => \pref_audio_es_edit,
    "/Menu/Preferences/audio_language" => \pref_audio_lang_edit,
    "/Menu/Preferences/audio_format"   => \audio_format_combo,
    "/Menu/Preferences/audio_channels" => \audio_channels_combo,
    "/Menu/Preferences/ppm2mpv_ntsc"   => \ppm2mpv_ntsc_edit,
    "/Menu/Preferences/ppm2mpv_pal"    => \ppm2mpv_pal_edit,

    "/Menu/Spacing/top"                => \top_spin_box,
    "/Menu/Spacing/heading"            => \heading_spin_box,
    "/Menu/Spacing/subheading"         => \subheading_spin_box,
    "/Menu/Spacing/button"             => \button_spin_box,
    "/Menu/Spacing/bottom"             => \bottom_spin_box,

    "/Menu/Fonts/heading"              => \heading_font_setting,
    "/Menu/Fonts/subheading"           => \subheading_font_setting,
    "/Menu/Fonts/buttons"              => \buttons_font_setting,

    "/Menu/Colors/heading"             => \heading_color_setting,
    "/Menu/Colors/subheading"          => \subheading_color_setting,
    "/Menu/Colors/button_base"         => \base_color_setting,
    "/Menu/Colors/button_hilited"      => \hilited_color_setting,
    "/Menu/Colors/button_selected"     => \selected_color_setting
  };

  load_settings ();

  unload ();
}


sub destroy
{
#  print STDERR "MainWindow::destroy\n";

  menu_preview -> remove_all ();
  menu_preview = undef;
  dvd_maker    = undef;
}


sub showEvent
{
  my $xl = copy_xml_label;
  my $bg = copy_button_group;
  my $lw = $xl -> width ();
  my $gw = $bg -> width ();
  my $fm = Qt::FontMetrics ($xl -> font ());
  my $tw = $fm -> boundingRect ($xl -> text ()) -> width ();
  my $m  = $fm -> width ("x") / 2;

  $bg -> setMaximumWidth ($tw + $gw - $lw + $m + 1);
}


sub closeEvent
{
#  print STDERR "MainWindow::closeEvent\n";

  my $ev = shift;

  # remove everything we created before actual dtor is called
  if (dev)
  {
    mtable_items     -> remove_all ();
    vts_list_items   -> remove_all ();
    title_list_items -> remove_all ();

    mtable_items     = undef;
    vts_list_items   = undef;
    title_list_items = undef;
  }

  close_settings ();

  $ev -> accept ();
}


# overload function of Qt::Dialog to prevent Esc to close window
sub keyPressEvent
{
  ;
}


sub load_or_unload # SLOT: ( bool )
{
  my $button_down = shift;

  if ($button_down)
  {
    load (device_edit -> currentText ());
  }
  else
  {
    unload ();
  }
}


sub load # SLOT: ( const QString & )
{
  my $dev = shift;

  return if (dev);

  dev = $dev;
  load_button -> toggle () unless (load_button -> isOn ());
  load_button -> setText (&trUtf8 ("Reading DVD..."));
  load_button -> adjustSize ();
  Qt::Application::processEvents ();

  my $dvd = DvdIfoRead -> new ($dev);
  load_button -> setText (&trUtf8 ("Release DVD"));

  unless ($dvd)
  {
    dev = undef;
    load_button -> toggle ();

    error (sprintf "%s: %s", &trUtf8 ("Failed reading DVD"),
	   scalar (stat ($dev)) ? &trUtf8 ("Unknown error") : $!);

    return;
  }

  dvd              = $dvd;
  title_list_items = TitleListItems ($dev, $dvd, title_list,
				     "title_list_items", vts_list);
  vts_list_items   = title_list_items -> vts_list_items ();
  mtable_items     = MenuTableItems (menu_table, "menu_table_items",
				     title_list_items, dvd);
  fpc_mgr          = FpcMgr (this, "fpc_mgr", fpc_title_combo,
			     fpc_audio_combo, fpc_subtitle_combo,
			     title_list_items, mtable_items);

  this -> connect (vts_list_items,
		   SIGNAL "total_selected_changed(int)",
		   SLOT   "total_selected_update(int)");
  this -> connect (vts_list_items,
		   SIGNAL "title_selected_changed(int)",
		   SLOT   "title_selected_update(int)");

  my $total_sectors = vts_list_items -> nr_of_total_sectors ();
  total_size_label -> setText (sprintf "%.2f GB",
			       $total_sectors / (512. * 1024.));

  my $vol_id = $dvd -> volume_identifier ();
  dvd_title_label -> setText ($vol_id);

  $vol_id =~ s/_/ /g;
  heading_edit -> setText ($vol_id);

  my $prefix     = read_setting ("/Installation/prefix");
  my $background = read_setting ("/Menu/Preferences/background");
  $background    = replace ($background, { "p" => $prefix });
  background_edit -> setText ($background);
  vts_list_items  -> size_update ();
  device_edit     -> clearFocus ();
  device_edit     -> setEnabled (0);
  selection_tab   -> setEnabled (1);
  menu_tab        -> setEnabled (1);
  copy_tab        -> setEnabled (1);
  tab_widget      -> setCurrentPage (0);

  my @devs = map { my @rv = ( $_ ) unless ($_ eq $dev); @rv }
                 split_setting (read_setting ("/General/DVD_read_devices"));
  unshift @devs, $dev;
  @devs = @devs [0..9] if (@devs > 10);
  write_setting ("/General/DVD_read_devices", join_setting (\@devs));
}


sub unload
{
  load_button   -> setText (&trUtf8 ("Read DVD"));
  tab_widget    -> setCurrentPage (0);
  selection_tab -> setEnabled (0);
  menu_tab      -> setEnabled (0);
  copy_tab      -> setEnabled (0);

  return unless (dev);

  device_edit         -> setEnabled (1);
  title_size_label    -> setText ("");
  selected_size_label -> setText ("");
  total_size_label    -> setText ("");
  dvd_title_label     -> setText ("");

  mtable_items     -> remove_all ();
  vts_list_items   -> remove_all ();
  title_list_items -> remove_all ();

  fpc_mgr          = undef;
  mtable_items     = undef;
  vts_list_items   = undef;
  title_list_items = undef;
  dvd              = undef;
  dev              = undef;
}


sub showExtension # SLOT: ( bool )
{
  my $show_it = shift;

  extension_shown = $show_it;
  SUPER -> showExtension ($show_it);

  vts_button -> setText ($show_it ?
			 &trUtf8 ("Hide Video Title Sets <<") :
			 &trUtf8 ("Show Video Title Sets >>"));
}


sub tab_changed # SLOT: ( QWidget * )
{
  my $tab = shift;

  my $tab_index = tab_widget -> indexOf ($tab);

  SUPER -> showExtension ($tab_index == 0) if (extension_shown);

  if ($tab_index == 1)		# menu
  {
    if (dev)
    {
      my $table_items = mtable_items;

      $table_items -> end_edit_mode ();
      $table_items -> update (1);
      fpc_mgr      -> update ();
    }
  }
  elsif ($tab_index == 5)	# about
  {
    my $fh;
    my $dvdauthor_version = &trUtf8 ("Failed to execute dvdauthor");

    if (open $fh, "-|", "dvdauthor -h 2>&1")
    {
      ($dvdauthor_version) = <$fh> =~ /version (.+)\.$/;
      close $fh;
    }

    my $text = sprintf
       '<center><h1><font color="#ff0000">qVamps</font></h1></center>' .
       '<p>%s: %s<br>%s: %s<br>%s: %s<br>%s: %s<br>%s: %s<br>%s: %s<br>' .
          '%s: %s<br>%s: %s<br>%s: %s<br>%s: %s<br>%s: %s<br>%s: %s</p>' .
       '<p>%s &lt vamps-adm@sourceforge.net&gt ,<br>%s /dev/null ;-)</p>',
       &trUtf8 ("qVamps version"), $QVamps::version,
       &trUtf8 ("rc file version"), read_setting ("/General/version"),
       &trUtf8 ("Perl version"), (sprintf "%vd", $^V),
       &trUtf8 ("PerlQt version"), $Qt::VERSION,
       &trUtf8 ("Qt version"), Qt::GlobalSpace::qVersion (),
       &trUtf8 ("dvdauthor version"), $dvdauthor_version,
       &trUtf8 ("Operating system"), $Config {"osname"},
       &trUtf8 ("Machine architecture"), $Config {"archname"},
       &trUtf8 ("User interface language"), read_setting ("/General/language"),
       &trUtf8 ("Installation prefix"), read_setting ("/Installation/prefix"),
       &trUtf8 ("Load prefix"), $QVamps::load_prefix,
       &trUtf8 ("qVamps home"), $QVamps::qvamps_home,
       &trUtf8 ("Please send positive feedback to"),
       &trUtf8 ("complaints go to");

    my $about_edit = about_edit;
    $about_edit -> setText ($text);
    $about_edit -> setMinimumWidth ($about_edit -> contentsWidth () + 2);
    $about_edit -> setMinimumHeight ($about_edit -> contentsHeight () + 2);

    my $color = $about_edit ->
      palette () -> color (&Qt::Palette::Active, &Qt::ColorGroup::Background);
    $about_edit -> setPaletteBackgroundColor ($color);
  }
}


sub total_selected_update # SLOT: ( int )
{
  my $total_selected = shift;

  selected_size_label -> setText (sprintf "%.2f GB",
				  $total_selected / (512. * 1024.));

  my $compression;

  if ($total_selected)
  {
    my $capacity = $dvdr_total_sectors - $dvdr_spare_sectors;
    $compression = sprintf "%d", $capacity * 100 / ($total_selected + 0.0);
    $compression = 100 if ($compression > 100);
  }
  else
  {
    $compression = 100;
  }

  vap_dialer -> setValue ($compression);
  vap_label  -> setText ("$compression%");
}


sub title_selected_update # SLOT: ( int )
{
  my $title_selected = shift;

  title_size_label -> setText (sprintf "%.2f GB",
			       $title_selected / (512. * 1024.));
}


sub copy_or_abort
{
  my $dvd_maker = dvd_maker;

  if ($dvd_maker)
  {
    dvd_maker = undef;

    $dvd_maker -> try_terminate ();

    copy_button -> setText (&trUtf8 ("Copy!"));
    load_button -> setEnabled (1);

    return;
  }

  my $capacity = $dvdr_total_sectors - $dvdr_spare_sectors;
  my $vap_fact = (vts_list_items -> nr_of_selected_sectors () + 0.0) /
                   $capacity;
  $vap_fact = 1.0 if ($vap_fact < 1.0);

  my $home      = $ENV {"HOME"};
  my $dvd_id    = dvd_id (dvd);
  my $dvd_dir   = $dvd_id;
  $dvd_dir      =~ s/ /_/g;
  my $base_path = read_setting ("/Dvdauthor/base_path");
  $base_path    =~ s/~/$home/;
  $base_path    = replace ($base_path, { "t" => $dvd_dir });

  mkpath ($base_path);

  my $mtable_items     = mtable_items;
  my $menu_box_checked = menu_check_box -> isChecked ();
  my $fpc_box_checked  = fpc_check_box -> isChecked ();
  my $add_unseen       = $menu_box_checked && !$mtable_items -> nr_of_items ();
  $mtable_items -> update ($add_unseen);
  fpc_mgr       -> update ();

  my $xml_writer = XmlWriter (dev, dvd, title_list_items,
			      vts_list_items, fpc_mgr, $mtable_items,
			      $vap_fact, $base_path, this, "xml_writer");

  my $stat = $xml_writer -> write ($fpc_box_checked, $menu_box_checked);
  $stat  ||= $xml_writer -> close ();

  return if ($stat);

  my $menu_preview = menu_preview;
  $menu_preview -> generate (this);

  my $make_menu = $menu_box_checked && $mtable_items -> nr_of_items ();

  if ($make_menu)
  {
    my $menu_writer = MenuWriter (mtable_items, $menu_preview,
				  $base_path, this, "menu_writer");

    $stat   = $menu_writer -> write_xml ();
    $stat ||= $menu_writer -> close ();
    $stat ||= $menu_writer -> write_images ();

    return if ($stat);
  }

  my $disk_change = disk_change_check_box -> isChecked ();
  my $rm_temps    = !keep_temps_check_box -> isChecked ();

  $dvd_maker = DvdMaker (log_viewer, this, "dvd_maker");
  dvd_maker  = $dvd_maker;

  copy_button -> setText (&trUtf8 ("Abort"));
  load_button -> setEnabled (0);

  $stat = $dvd_maker -> write_script ($base_path, $make_menu,
					 $disk_change, $rm_temps, $dvd_id);

  if (!$stat &&
      (radio_button_2 -> isChecked () || radio_button_3 -> isChecked ()))
  {
    $stat   = $dvd_maker -> run_spumux ($base_path, $make_menu, $rm_temps);
    $stat ||= $dvd_maker -> run_dvdauthor ($base_path, $rm_temps);

    if (!$stat && radio_button_3 -> isChecked ())
    {
      info (&trUtf8 ("Please insert blank DVD into burner")) if ($disk_change);
      $stat = $dvd_maker -> run_burn_cmd ($base_path, $dvd_id);
    }
  }

  copy_button -> setText (&trUtf8 ("Copy!"));
  load_button -> setEnabled (1);

  if (dvd_maker)
  {
    if ($stat)
    {
      error ('<font color="#ff0000">' . &trUtf8 ("Copy failed!") . '</font> ' .
	     &trUtf8 ("You may find further information in the output log."));
    }
    else
    {
      info (&trUtf8 ("Copy successfully completed"));
    }
  }
  else
  {
    info (&trUtf8 ("Copy aborted!"));
  }

  dvd_maker = undef;
}


sub dvd_id
{
  my $dvd = shift;

  my $id = $dvd -> volume_identifier ();

  return $id if ($id);

  return unpack ("H*", $dvd -> disc_identifier ());
}


sub menu_table_item_up
{
  mtable_items -> up_item ();
}


sub menu_table_item_down
{
  mtable_items -> down_item ();
}


sub menu_table_item_add
{
  mtable_items -> add_item ();
}


sub menu_table_item_remove
{
  mtable_items -> remove_item ();
}


sub menu_table_renumber_labels
{
  mtable_items -> renumber_labels ();
}


sub background_file_dialog
{
  my $filename = background_edit -> text ();
  $filename = Qt::FileDialog::getOpenFileName ($filename,
    "Images (*.jpg *.jpeg *.png *.pnm *.ppm *.bmp);;" .
    "More Images (*.xbm *.xpm *.pgm *.pbm);;" .
    "DVD Program Streams (*.mpg *.mpeg)",
    this, "background_file_dialog", "Menu Background Selection");
  background_edit -> setText ($filename);
}


sub show_menu_preview
{
  my $menu_preview = menu_preview;

  $menu_preview -> preview (this);
  $menu_preview -> show ();
}


sub close_menu_preview # SLOT: ( bool )
{
  my $on = shift;

  menu_preview -> close () unless ($on);
}


sub background_filename
{
  return background_edit -> text ();
}


sub heading
{
  return heading_edit -> text ();
}


sub subheading
{
  return subheading_edit -> text ();
}


sub menu_table_items
{
  return mtable_items;
}


sub fpc_title_activated
{
  my $ttn = shift;

  fpc_mgr -> title_changed ($ttn);
}


sub get_heading_font
{
  heading_font_setting = get_font ("/Menu/Fonts/heading");
}


sub get_subheading_font
{
  subheading_font_setting = get_font ("/Menu/Fonts/subheading");
}


sub get_buttons_font
{
  buttons_font_setting = get_font ("/Menu/Fonts/buttons");
}


sub get_font
{
  my $key = shift;

  my $ok;
  my $font = Qt::Font (split_setting (read_setting ($key)));
  $font    = Qt::FontDialog::getFont ($ok, $font);

  return join_setting ([ $font -> family (), $font -> pointSize (), 50, 0 ]);
}


sub get_heading_color
{
  heading_color_setting = get_color ("/Menu/Colors/heading");
}


sub get_subheading_color
{
  subheading_color_setting = get_color ("/Menu/Colors/subheading");
}


sub get_base_color
{
  base_color_setting = get_color ("/Menu/Colors/button_base");
}


sub get_hilited_color
{
  hilited_color_setting = get_color ("/Menu/Colors/button_hilited");
}


sub get_selected_color
{
  selected_color_setting = get_color ("/Menu/Colors/button_selected");
}


sub get_color
{
  my $key = shift;

  my $color = Qt::Color (split_setting (read_setting ($key)));
  $color    = Qt::ColorDialog::getColor ($color);

  return join_setting ([ $color -> red (),
			 $color -> green (), $color -> blue () ]);
}


sub load_settings
{
  while (my ($key, $ref) = each %{&settings_mapping})
  {
    my $value = read_setting ($key);

    if (ref ($ref) eq "SCALAR")
    {
      ${$ref} = $value;
    }
    else
    {
      for (${$ref})
      {
	if (/LineEdit/)
	{
	  ${$ref} -> setText ($value);
	  next;
	}

	if (/SpinBox/)
	{
	  ${$ref} -> setValue ($value);
	  next;
	}

	if (/ComboBox/)
	{
	  ${$ref} -> setCurrentText ($value);
	  next;
	}
      }
    }
  }
}


sub save_settings
{
  while (my ($key, $ref) = each %{&settings_mapping})
  {
    my $value;

    if (ref ($ref) eq "SCALAR")
    {
      $value = ${$ref};
    }
    else
    {
      for (${$ref})
      {
	if (/LineEdit/)
	{
	  $value = ${$ref} -> text ();
	  next;
	}

	if (/SpinBox/)
	{
	  $value = ${$ref} -> value ();
	  next;
	}

	if (/ComboBox/)
	{
	  $value = ${$ref} -> currentText ();
	  next;
	}
      }
    }

    write_setting ($key, $value);
  }

  $dvdr_total_sectors =
    ${settings_mapping -> {"/Vamps/dvdr_total_sectors"}} -> value ();
  $dvdr_spare_sectors =
    ${settings_mapping -> {"/Vamps/dvdr_spare_sectors"}} -> value ();
}
